BEGIN_GTBMOUSENS


inline const Point3 &Camera::origin() const
{
	return _cs.origin();
}


inline const Vector3 &Camera::backwards() const
{
	return _cs.z();
}


inline Vector3 Camera::towards() const
{
	return -_cs.z();
}


inline const Vector3 &Camera::up() const
{
	return _cs.y();
}


inline Vector3 Camera::down() const
{
	return -_cs.y();
}


inline const Vector3 &Camera::right() const
{
	return _cs.x();
}


inline Vector3 Camera::left() const
{
	return -_cs.x();
}


inline real_t Camera::x_fov() const
{
	return _x_fov;
}


inline real_t Camera::y_fov() const
{
	return _y_fov;
}


inline real_t Camera::aspect() const
{
	// real_t w = 2.0 * _near_distance * tan(_x_fov);
	// real_t h = 2.0 * _near_distance * tan(_y_fov);
	// return w / h;
	return tan(_x_fov) / tan(_y_fov);
}


inline real_t Camera::near_distance() const
{
	return _near_distance;
}


inline real_t Camera::far_distance() const
{
	return _far_distance;
}


inline const CoordinateSystem &Camera::coordinate_system() const
{
	return _cs;
}


inline Matrix4 Camera::matrix() const
{
	return _cs.matrix();
}


inline Matrix4 Camera::inverse_matrix() const
{
	return _cs.inverse_matrix();
}


inline bool Camera::sees(const Point3 &p) const
{
	for (unsigned i = 0; i < 6; i++) {
		if (_planes[i].signed_distance(p) <= 0.0) {
			return false;
		}
	}
	return true;
}


inline void Camera::pitch(real_t angle)
{
//	rotate(Line3(origin(), right()), angle);
}


inline void Camera::yaw(real_t angle)
{
//	rotate(Line3(origin(), up()), angle);
}


inline void Camera::roll(real_t angle)
{
//	rotate(Line3(origin(), towards()), angle);
}


END_GTBMOUSENS
