#include "gtbmouse.h"
#ifndef WIN32
#include <gtb/graphics/line3.hpp>
#include <gtb/graphics/ray3.hpp>
#endif // WIN32


#ifdef OUTLINE
#define inline
#include <gtb/graphics/line3.ipp>
#undef inline
#endif


BEGIN_GTBMOUSENS


const Line3 LINE3_POSITIVE_X(Point3(0.0, 0.0, 0.0), Vector3(1.0, 0.0, 0.0));
const Line3 LINE3_NEGATIVE_X(Point3(0.0, 0.0, 0.0), Vector3(-1.0, 0.0, 0.0));
const Line3 LINE3_POSITIVE_Y(Point3(0.0, 0.0, 0.0), Vector3(0.0, 1.0, 0.0));
const Line3 LINE3_NEGATIVE_Y(Point3(0.0, 0.0, 0.0), Vector3(0.0, -1.0, 0.0));
const Line3 LINE3_POSITIVE_Z(Point3(0.0, 0.0, 0.0), Vector3(0.0, 0.0, 1.0));
const Line3 LINE3_NEGATIVE_Z(Point3(0.0, 0.0, 0.0), Vector3(0.0, 0.0, -1.0));


Line3::Line3()
	: _p(Point3(0.0, 0.0, 0.0)),
	  _d(Vector3(1.0, 0.0, 0.0))
{
}


Line3::Line3(const Line3 &l)
	: _p(l._p),
	  _d(l._d)
{
}


Line3::Line3(const Point3 &p, const Point3 &q)
	: _p(p),
	  _d(q - p)
{
	_d.normalize();
}


Line3::Line3(const Point3 &p, const Vector3 &d)
	: _p(p),
	  _d(d)
{
	_d.normalize();
}


Line3::Line3(const Ray3 &r)
	: _p(r.source()),
	  _d(r.direction())
{
}


END_GTBMOUSENS
