#include "gtbmouse.h"
#ifndef WIN32
#include <gtb/graphics/plane.hpp>
#include <gtb/graphics/polygon3.hpp>
#endif // WIN32


#ifdef OUTLINE
#define inline
#include <gtb/graphics/plane.ipp>
#undef inline
#endif


BEGIN_GTBMOUSENS


Plane::Plane()
	: _n(Vector3(0.0, 0.0, 1.0)),
	  _D(0.0)
{
}


Plane::Plane(const Vector3 &arg_n, real_t arg_D)
	: _n(arg_n),
	  _D(arg_D)
{
}


Plane::Plane(const Point3 &A, const Point3 &B, const Point3 &C)
{
	assert(!Point3::collinear(A, B, C));
	_n = Point3::normal(A, B, C);

//  	if (!real::is_equal(_n.squared_length(), 1.0, 0.00001)) {
//  		fprintf(stderr, "WARNING: bad plane normal\n");
//  		fprintf(stderr, "n = (%f %f %f)\n", _n.x(), _n.y(), _n.z());
//  		fprintf(stderr, "|n| = %f\n", _n.squared_length());
//  		//exit(EXIT_FAILURE);
//  	}

	_D = -(_n * A);

//  	if (!real::is_zero(_n * A + _D, 0.00001)) {
//  		fprintf(stderr, "WARNING: bad plane equation\n");
//  		fprintf(stderr, "np + D = %f\n", _n * A + _D);
//  		//exit(EXIT_FAILURE);
//  	}
}


Plane::Plane(const Plane &p)
	: _n(p._n),
	  _D(p._D)
{
}


bool Plane::contains(const Point3 &p) const
{
return false;
}



//
// BUGBUG: assume real_t is double
//
void Plane::read(FILE *fp)
{
}

void Plane::write(FILE *fp) const
{
}

END_GTBMOUSENS
