#ifndef GTB_PLANE_INCLUDED
#define GTB_PLANE_INCLUDED

#include "gtbmousecommon.h"
#include "vector3.hpp"
//#include "segment3.hpp"
//#include "RSTPlane.hpp"

BEGIN_GTBMOUSENS


class Segment3;
class Polygon3;


class Plane {
public:
	Plane();
	Plane(const Plane &p);
	Plane(const Vector3 &normal, real_t D);
	Plane(const Point3 &A, const Point3 &B, const Point3 &C);
	Plane(const Polygon3 &p);

//    Plane(const CPlaneRST& rhs);

	Plane &operator=(const Plane &p);

	Vector3 &normal();
	const Vector3 &normal() const;
    void set_normal(const Vector3& n);
	real_t D() const;
	void setD(real_t v_D);

	bool operator==(const Plane &p) const;
	bool operator!=(const Plane &p) const;

	real_t distance(const Point3 &) const;
	real_t signed_distance(const Point3 &) const;

	bool contains(const Point3 &p) const;
#if 0
	bool intersects(const Segment3 &segment,
			Point3 &hit_point,
			real_t &hit_time) const;
#endif
	void read(FILE *fp);
	void write(FILE *fp) const;

protected:
	// n.p + D = 0
	Vector3 _n;
	real_t _D;
};


END_GTBMOUSENS

#ifndef OUTLINE
#include "plane.ipp"
#endif

#endif // GTB_PLANE_INCLUDED
